//+------------------------------------------------------------------+
//|                                                            2.mq4 |
//|                                 Copyright  2010, XrustSolution. |
//|                                           mail: xrustx@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, XrustSolution."
#property link      "mail: xrustx@gmail.com"
#define empty EMPTY_VALUE
void GetInfo(string in){Print(in);return;}
extern	bool ESN = true;
//+------------------------------------------------------------------+
//|      ,                           |
//|    :                   |
//|  TP  SL      : tp<=0 &&|| sl<=0           |
//|                                                |
//+------------------------------------------------------------------+
bool OrderSet(int type,//  
           double lots,//  
           double sl    = 0,
           double tp    = 0,
           string comm  = "",
              int magik = 0,
           string symb  = "",   
           double price = 0,
              int expr  = 0){
   if(symb == ""){symb  = Symbol();}              
//+------------------------------------------------------------------+ 
   int    stlv =MarketInfo(symb,MODE_STOPLEVEL);
   double ask = NormalizeDouble(MarketInfo(symb,MODE_ASK),MarketInfo(symb,MODE_DIGITS));
   double bid = NormalizeDouble(MarketInfo(symb,MODE_BID),MarketInfo(symb,MODE_DIGITS));
   double margin = MarketInfo(Symbol(),MODE_MARGINREQUIRED)*lots;
   double free   = AccountFreeMargin();
   double minlot = MarketInfo(symb,MODE_MINLOT);
   double spr  = MarketInfo(Symbol(),MODE_SPREAD)*Point;
   int    slip = MarketInfo(symb,MODE_SPREAD)*mno();
   int   digit = MarketInfo(Symbol(),MODE_DIGITS);
   bool   edit_pr = true;
//+------------------------------------------------------------------+  
   if(type<0){return(false);}          
   if(type>1&&price==0){GetInfo("ERROR: NO PRICE FOR ORDERSEND!");return(false);}    
   if(lots==0){GetInfo("ERROR: LOT = 0 FOR ORDERSEND!");return(false);}
	double ltstep = MarketInfo(Symbol(),MODE_LOTSTEP);
	if(ltstep==0.01){lots = NormalizeDouble(lots,2);}else{lots = NormalizeDouble(lots,1);}
   if(margin>free){GetInfo("ERROR: YOU NOT HAVE MONEY FOR ORDERSEND!");return(false);}
   if(type == 2 || type == 5 ){
      if(bid - price < stlv * Point){
         GetInfo("ERROR: Wrong Price for "+GetNameOP(type)+" OrderSend !"+price+"  Bid = "+bid);
         if(!edit_pr){return(false);}
         price = bid -  stlv * Point;
         GetInfo("CORRECT: Open Price was corrected to = "+price+"  Bid = "+bid);
      }
   }  
   if(type == 3 || type == 4 ){
      if(price - ask < stlv * Point){
         GetInfo("ERROR: Wrong Price for "+GetNameOP(type)+" OrderSend !"+price+"  Ask = "+ask);
         if(!edit_pr){return(false);}
         price = ask +  stlv * Point;
         GetInfo("CORRECT: Open Price was corrected to = "+price+"  Bid = "+bid);
      }
   }    
//+------------------------------------------------------------------+    
   if(lots<minlot){lots=minlot;}  
   if(type == 0 ){price = ask;}
   if(type == 1 ){price = bid;}         
   if(sl<0){
      sl=MathAbs(sl);
      if(sl<stlv){sl=stlv;}
      if(type==0){sl=bid-(sl*Point*mno());}
      if(type==1){sl=ask+(sl*Point*mno());}
      if(type==2||type==4){sl=price-(sl*Point*mno());}
      if(type==3||type==5){sl=price+(sl*Point*mno());}
   }
   sl = NormalizeDouble(MathAbs(sl),MarketInfo(symb,MODE_DIGITS));
   if(tp<0){
      tp=MathAbs(tp);
      if(tp<stlv){tp=stlv;}
      if(type==0){tp=ask+(tp*Point*mno());}
      if(type==1){tp=bid-(tp*Point*mno());}
      if(type==2||type==4){tp=price+(tp*Point*mno());}
      if(type==3||type==5){tp=price-(tp*Point*mno());}
   }
   tp = NormalizeDouble(MathAbs(tp),MarketInfo(symb,MODE_DIGITS));
//+------------------------------------------------------------------+
   if(stlv == 0 || ESN){
      int ticket;
      GetLastError();
      RefreshRates();
      ticket = OrderSend(symb,
                   type,
                   lots,
                  price, 
                   slip,
                     0,
                     0,
                   comm,
                  magik,
                   expr,
          GetOrdCl(type));
      if(ticket<1){
         GetInfo(StringConcatenate("Error for order Send  ",GetNameOP(type)," Price = ",dts(price,digit),"  Stoploss = ",dts(sl,digit)," Takeprofit = ",dts(tp,digit)));
         Fun_Error(GetLastError());
         return(false);   
      }else{
         if(OrdModify(sl,tp,empty,ticket,magik,type)){GetInfo(StringConcatenate(ticket,"  Order "+GetNameOP(type)+" sendet"));}
         return(true);
      }   
   }else{
      GetLastError();
      RefreshRates();
      if(OrderSend(symb,
                   type,
                   lots,
                  price, 
                   slip,
                     sl,
                     tp,
                   comm,
                  magik,
                   expr,
          GetOrdCl(type)
      )<1){
         GetInfo(StringConcatenate("Error for order Send  ",GetNameOP(type)," price = ",dts(price,digit),"  Stoploss = ",dts(sl,digit)," Takeprofit = ",dts(tp,digit)));
         Fun_Error(GetLastError());
         return(false);   
      }else{
         GetInfo("Order "+GetNameOP(type)+" sendet");
         return(true);
      }   
   }    
//+----+           
return(false);}
//+------------------------------------------------------------------+
//|      .                           |
//|     ,               |
//|    ,,.     "All" - |
//|    ,   DeleteAll()                      |
//+------------------------------------------------------------------+
bool OrdClose(int magik  = -1,
              int type   = -1,//=10   ; =11    
              int ticket = -1,
           string symb   = "",
           double cLot	 = -1	   
              ){int   digit = MarketInfo(Symbol(),MODE_DIGITS);double lot;
//+------------------------------------------------------------------+
	if(cLot==0){return;}
   if(symb==""){symb=Symbol();}
   int slip = MarketInfo(symb,MODE_SPREAD)*mno();
   double ltstp = MarketInfo(Symbol(),MODE_LOTSTEP);
   if(ltstp == 0.1){int ltdg = 1;}
   if(ltstp == 0.01){   ltdg = 2;} 
   if(ticket>0){
      GetLastError();
      RefreshRates();
      if(OrderSelect(ticket,SELECT_BY_TICKET)){
         if(OrderCloseTime()!=0){return;}
         if(OrderType()<2){
         	lot = OrderLots();
         	if(cLot>0){
         		lot = NormalizeDouble(cLot,ltdg);
         		if(lot>OrderLots()){lot=OrderLots();}
         		if(lot<MarketInfo(Symbol(),MODE_MINLOT)){lot=MarketInfo(Symbol(),MODE_MINLOT);}
         	}
            if(!OrderClose(OrderTicket(),
                             			 lot,
       NormalizeDouble(OrderClosePrice(),MarketInfo(symb,MODE_DIGITS)),
                                    slip,
                          GetOrdCl(type)
                          )
            ){
               Fun_Error(GetLastError());
               return(false);              
            }else{
               GetInfo("Order "+GetNameOP(OrderType())+" closed");
               return(true);
            }                          
         }else{
            if(!OrderDelete(OrderTicket(),GetOrdCl(type))){
               Fun_Error(GetLastError());
               return(false);              
            }else{
               GetInfo("Order "+GetNameOP(OrderType())+" closed");
               return(true);
            }
         }
      }
   }else{
//+------------------------------------------------------------------+
   for(int i=OrdersTotal()-1;i>=0;i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderCloseTime()!=0){continue;}
         if(symb!="All"){
            if(OrderSymbol()!=symb){continue;}
            if(type>=0&&type<6){if(OrderType()!=type){continue;}}
            if(type==10){if(OrderType()>1){continue;}}
            if(type==11){if(OrderType()<2){continue;}}
            if(magik>0){if(OrderMagicNumber()!=magik){continue;}}
         }
         if(OrderType()<2){
         	lot = OrderLots();
         	if(cLot>0){
         		lot = NormalizeDouble(cLot,ltdg);
         		if(lot>OrderLots()){lot=OrderLots();}
         		if(lot<MarketInfo(Symbol(),MODE_MINLOT)){lot=MarketInfo(Symbol(),MODE_MINLOT);}
         	}
         	Print("Close for opposite ",type,"  ",OrderType());
            if(!OrderClose(OrderTicket(),
                             			 lot,
       NormalizeDouble(OrderClosePrice(),MarketInfo(symb,MODE_DIGITS)),
                                    slip,
                          GetOrdCl(type)
                          )
            ){
               Fun_Error(GetLastError());
               return(false);              
            }else{
               GetInfo("Order "+GetNameOP(OrderType())+" closed");
            }                          
         }else{
            if(!OrderDelete(OrderTicket(),GetOrdCl(type))){
               Fun_Error(GetLastError());
               return(false);              
            }else{
               GetInfo("Order "+GetNameOP(OrderType())+" closed");
            }
         }
      }
   }          
//-----+
	}   
return(true);}
//+------------------------------------------------------------------+
//|       .           |
//|      ,      .     |
//|     -  , |
//|   .E                  |
//|                       "empty" ,  EMPTY_VALUE.   | 
//+------------------------------------------------------------------+
bool OrdModify(double sl  = empty,
               double tp  = empty,
               double pr  = empty,
               int ticket = -1,
               int magik  = -1,
               int type   = -1,//=10   ; =11    
            string symb   = ""   
               ){int   digit = MarketInfo(Symbol(),MODE_DIGITS);
//+------------------------------------------------------------------+
   if(symb==""){symb=Symbol();}
   double slip = MarketInfo(symb,MODE_SPREAD)*mno();
   double stlv = MarketInfo(symb,MODE_STOPLEVEL)*Point*mno();
   int    stli = MarketInfo(symb,MODE_STOPLEVEL);
   double ask  = NormalizeDouble(MarketInfo(symb,MODE_ASK),MarketInfo(symb,MODE_DIGITS));
   double bid  = NormalizeDouble(MarketInfo(symb,MODE_BID),MarketInfo(symb,MODE_DIGITS));
   if(sl<0){if(MathAbs(sl)<stli){sl=-stli;}}
   if(tp<0){if(MathAbs(tp)<stli){tp=-stli;}}
   double newPr,newSl,newTp;
   if(ticket>0){
      GetLastError();
      RefreshRates();
      if(OrderSelect(ticket,SELECT_BY_TICKET)){
         if(OrderCloseTime()!=0){GetInfo("This Order is already closed"); return;}
         int    Typ = OrderType();
         double Oop = OrderOpenPrice();
         double Ocp = OrderClosePrice();
         double Osl = OrderStopLoss();
         double Otp = OrderTakeProfit();
         if(Typ<2){
            if(pr!= empty){newPr=empty;GetInfo("MODIFY ERROR:You can not change the OpenPrice() for market order!");return;} 
         }else{
         	newPr=pr;
         }
         if(Typ == 0 ||Typ == 2 || Typ == 4){
            if(sl>0&&sl!=empty){
               if(bid - sl >= stlv){
                  newSl=nd(sl);
               }else{
                  if(Typ!=0){
                     newSl=nd(sl);
                  }else{
                     GetInfo("MODIFY ERROR: Wrong Stoploss = "+dts(sl,digit));
                     return;
                  }
               }
            }
            if(sl<0&&sl!=empty){
               newSl=nd(Ocp-MathAbs(sl)*Point*mno());
               if(bid - newSl < stlv){
                  if(Typ!=0){
                     newSl=nd(Ocp-MathAbs(sl)*Point*mno());
                  }else{
                     GetInfo("MODIFY ERROR: Wrong Stoploss = "+dts(newSl,digit));
                     return;
                  }
               }
            }
            if(tp>0&&tp!=empty){
               if(tp - ask >= stlv){
                  newTp=nd(tp);
               }else{
                  if(Typ!=0){
                     newTp=nd(tp);
                  }else{
                     GetInfo("MODIFY ERROR: Wrong Takeprofit = "+tp);
                     return;
                  }
               }
            }
            if(tp<0&&tp!=empty){
               newTp=nd(Oop+MathAbs(tp)*Point*mno());
               if(newTp - ask < stlv){
                  if(Typ!=0){
                     newTp=nd(tp);
                  }else{   
                     GetInfo("MODIFY ERROR: Wrong Takeprofit = "+dts(tp,digit));
                     return;
                  }   
               }
            }
         }
         if(Typ == 1 ||Typ == 3 || Typ == 5){
            if(sl>0&&sl!=empty){
               if(sl - ask >= stlv){
                  newSl=nd(sl);
               }else{
                  if(Typ!=1){
                     newSl=nd(sl);
                  }else{
                     GetInfo("MODIFY ERROR: Wrong Stoploss = "+dts(sl,digit));
                     return;
                  }
               }
            }
            if(sl<0&&sl!=empty){
               newSl=nd(Ocp+MathAbs(sl)*Point*mno());
               if(newSl - ask < stlv){
                  if(Typ!=1){
                     newSl=nd(Ocp+MathAbs(sl)*Point*mno());
                  }else{
                     GetInfo("MODIFY ERROR: Wrong Stoploss = "+dts(newSl,digit));
                     return;
                  }
               }
            }
            if(tp>0&&tp!=empty){
               if(bid - tp >= stlv){
                  newTp=nd(tp);
               }else{
                  if(Typ!=1){
                     newTp=nd(tp);
                  }else{
                     GetInfo("MODIFY ERROR: Wrong Takeprofit = "+tp);
                     return;
                  }
               }
            }
            if(tp<0&&tp!=empty){
               newTp=nd(Oop+MathAbs(tp)*Point*mno());
               if(bid - newTp < stlv){
                  if(Typ!=1){
                     newTp=nd(Oop+MathAbs(tp)*Point*mno());
                  }else{
                     GetInfo("MODIFY ERROR: Wrong Takeprofit = "+dts(tp,digit));
                     return;
                  }
               }
            }
         }             
         if(sl==0){newSl=0;}
         if(tp==0){newTp=0;}
         if(sl==empty){newSl=OrderStopLoss();}
         if(tp==empty){newTp=OrderTakeProfit();}
         if(pr==0||pr==empty){newPr=OrderOpenPrice();}
         if(nd(newPr)==nd(OrderOpenPrice())&&nd(newSl)==nd(OrderStopLoss())&&nd(newTp)==nd(OrderTakeProfit())){return(true);}  
         if(nd(newPr)!=nd(OrderOpenPrice())||nd(newSl)!=nd(OrderStopLoss())||nd(newTp)!=nd(OrderTakeProfit())){
            if(!OrderModify(OrderTicket(),
                                    newPr,
                                    newSl,
                                    newTp,
                                        0,
                                 GetOrdCl(OrderType())
                            )
               ){               
               Fun_Error(GetLastError());
               GetInfo("ERROR "+GetLastError()+" : "+nd(newPr)+"!="+nd(OrderOpenPrice())+"&&"+nd(newSl)+"!="+nd(OrderStopLoss())+"&&"+nd(newTp)+"!="+nd(OrderTakeProfit()));
               return;              
            }else{
               GetInfo(StringConcatenate("Order "+GetNameOP(OrderType())+" Modifiet Price = ",dts(newPr,digit),"  NewStop =",dts(newSl,digit),"  NewTake =",dts(newTp,digit)));
               return;
            }
         }
      }else{Print("Order was not found");Fun_Error(GetLastError());return(false);}   
   }else{
      for(int i=OrdersTotal();i>=0;i--){
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
            if(OrderCloseTime()!=0){continue;}
            if(symb!="All"){
               if(OrderSymbol()!=symb){continue;}
               if(type>=0&&type<6){if(OrderType()!=type){continue;}}
               if(type==10){if(OrderType()>1){continue;}}
               if(type==11){if(OrderType()<2){continue;}}
               if(magik>=0){if(OrderMagicNumber()!=magik){continue;}}
            }
            Typ = OrderType();
            Oop = OrderOpenPrice();
            Ocp = OrderClosePrice();
            Osl = OrderStopLoss();
            Otp = OrderTakeProfit();
            if(Typ<2){
               if(pr!= empty){newPr=empty;GetInfo("ERROR:You can not change the OpenPrice() for market order!");return;} 
            }
            if(Typ == 0 ||Typ == 2 || Typ == 4){
               if(sl>0&&sl!=empty){if(bid - sl >= stlv){newSl=nd(sl);}else{GetInfo("For Order "+GetNameOP(Typ)+"  Ticket = "+OrderTicket()+" MODIFY  ERROR: Wrong Stoploss = "+dts(sl,digit)+"  Current Price = "+dts(Bid,digit));newSl = Osl;}}
               if(sl<0&&sl!=empty){newSl=nd(Ocp-MathAbs(sl)*Point*mno());if(bid - newSl < stlv){GetInfo("For Order "+GetNameOP(Typ)+"  Ticket = "+OrderTicket()+" MODIFY  ERROR: Wrong Stoploss = "+dts(newSl,digit)+"  Current Price = "+dts(Bid,digit)); newSl = Osl;}}
               if(tp>0&&tp!=empty){if(tp - ask >= stlv){newTp=nd(tp);}else{GetInfo("For Order "+GetNameOP(Typ)+"  Ticket = "+OrderTicket()+" MODIFY  ERROR: Wrong Takeprofit = "+dts(tp,digit)+"  Current Price = "+dts(Bid,digit));newTp = Otp;}}
               if(tp<0&&tp!=empty){newTp=nd(Oop+MathAbs(tp)*Point*mno());if(newTp - ask < stlv){GetInfo("For Order "+GetNameOP(Typ)+"  Ticket = "+OrderTicket()+" MODIFY  ERROR: Wrong Takeprofit = "+dts(newTp,digit)+"  Current Price = "+dts(Bid,digit));newTp = Otp;}}
            }
            if(Typ == 1 ||Typ == 3 || Typ == 5){
               if(sl>0&&sl!=empty){if(sl - ask >= stlv){newSl=nd(sl);}else{GetInfo("For Order "+GetNameOP(Typ)+"  Ticket = "+OrderTicket()+" MODIFY  ERROR: Wrong Stoploss = "+dts(sl,digit)+"  Current Price = "+dts(Bid,digit));newSl = Osl;}}
               if(sl<0&&sl!=empty){newSl=nd(Ocp+MathAbs(sl)*Point*mno());if(newSl - ask < stlv){GetInfo("For Order "+GetNameOP(Typ)+"  Ticket = "+OrderTicket()+" MODIFY  ERROR: Wrong Stoploss = "+dts(newSl,digit)+"  Current Price = "+dts(Bid,digit));newSl = Osl;}}
               if(tp>0&&tp!=empty){if(bid - tp >= stlv){newTp=nd(tp);}else{GetInfo("For Order "+GetNameOP(Typ)+"  Ticket = "+OrderTicket()+" MODIFY  ERROR: Wrong Takeprofit = "+dts(tp,digit)+"  Current Price = "+dts(Bid,digit));newTp = Otp;}}
               if(tp<0&&tp!=empty){newTp=nd(Oop-MathAbs(tp)*Point*mno());if(bid - newTp < stlv){GetInfo("For Order "+GetNameOP(Typ)+"  Ticket = "+OrderTicket()+" MODIFY  ERROR: Wrong Takeprofit = "+dts(newTp,digit)+"  Current Price = "+dts(Bid,digit));newTp = Otp;}}
            }            
            if(sl==0){newSl=0;}
            if(tp==0){newTp=0;}
            if(sl==empty){newSl=OrderStopLoss();}
            if(tp==empty){newTp=OrderTakeProfit();}
            if(pr==0||pr==empty){newPr=OrderOpenPrice();}
            if(nd(newPr)!=nd(OrderOpenPrice())||nd(newSl)!=nd(OrderStopLoss())||nd(newTp)!=nd(OrderTakeProfit())){
               if(!OrderModify(OrderTicket(),
                                       newPr,
                                       newSl,
                                       newTp,
                                           0,
                                    GetOrdCl(OrderType())
                               )
                  ){               
                  Fun_Error(GetLastError());
                  return;              
               }else{
                  GetInfo(StringConcatenate("Order "+GetNameOP(OrderType())+" Modifiet Price = ",dts(newPr,digit),"  NewStop =",dts(newSl,digit),"  NewTake =",dts(newTp,digit)));
               }
            }            
         }
      }            
   }
   return;         
}
//+------------------------------------------------------------------+
//|                   |
//|  Checks whether the opened last the order on the same candle     |
//+------------------------------------------------------------------+
bool IfOrdOpClSelfBar(int magik = 0, int bar = 0, int typ = -1,string sy = "",int per = 0){
   if(sy == ""){sy = Symbol();}
   if(per==0){per=Period();}
   for(int i = OrdersTotal(); i>=0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()!=sy){continue;}
         if(OrderType()==typ||typ==-1){
            if(OrderMagicNumber()==magik||magik==0){
               if(OrderOpenTime()>=iTime(sy,per,bar)){return(true);}
            }
         }
      }
   }
   for(i = OrdersHistoryTotal(); i>=0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
         if(OrderSymbol()!=sy){continue;}
         if(OrderType()==typ||typ==-1){
            if(OrderMagicNumber()==magik||magik==0){
               if(OrderOpenTime()>=iTime(sy,per,bar)){return(true);}
            }
         }
      }
   }   
   return(false);
}
//+------------------------------------------------------------------+
//|                   |
//|  Checks whether the opened last the order on the same candle     |
//+------------------------------------------------------------------+
bool IfOrdClSelfBar(int magik = 0, int bar = 0, int typ = -1,string sy = "",int per = 0){
   if(sy == ""){sy = Symbol();}
   if(per==0){per=Period();}
   for(int i = OrdersHistoryTotal(); i>=0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
         if(OrderSymbol()!=sy){continue;}
         if(OrderType()==typ||typ==-1){
            if(OrderMagicNumber()==magik||magik==0){
               if(OrderCloseTime()>=iTime(sy,per,bar)){return(true);}
            }
         }
      }
   }
   return(false);
}
//+------------------------------------------------------------------+
//|                   |
//|  Checks whether the opened last the order on the same candle     |
//+------------------------------------------------------------------+
bool IfOrdOpSelfBar(int magik = 0,  int bar = 0, int typ = -1,string sy = "",int per = 0){
   if(sy == ""){sy = Symbol();}
   if(per==0){per=Period();}
   for(int i = OrdersTotal(); i>=0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()!=sy){continue;}
         if(OrderType()==typ||typ==-1){
            if(OrderMagicNumber()==magik||magik==0){
               if(OrderOpenTime()>=iTime(sy,per,0)){return(true);}
            }
         }
      }
   }
   return(false);
}
//+------------------------------------------------------------------+
//|                             |
//|  Counts open orders under the conditions                         |
//+------------------------------------------------------------------+
int OpOrdCount(int magik = 0, int typ = -1,string sy = ""){int i,c;
   if(sy == ""){sy = Symbol();}
   for(i = OrdersTotal()-1; i>=0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()!=sy){continue;}
         if(OrderCloseTime()!=0){continue;}
         if(OrderType()==typ||typ==-1){
            if(OrderMagicNumber()==magik||magik==0){c++;}
         }
      }
   }
   return(c);
}
//+------------------------------------------------------------------+
//|                             |
//|  Counts closed orders under the conditions                       |
//+------------------------------------------------------------------+
int ClOrdCount(int magik = 0, int typ = -1,string sy = ""){int i,c;
   if(sy == ""){sy = Symbol();}
   for(i = OrdersHistoryTotal(); i>=0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
         if(OrderSymbol()!=sy){continue;}
         if(OrderCloseTime()==0){continue;}
         if(OrderType()==typ||typ==-1){
            if(OrderMagicNumber()==magik||magik==0){c++;}
         }
      }
   }
   return(c);
}
//+------------------------------------------------------------------+
//|     			                        |
//|  Last open order OrderOpenPrice				                        |
//+------------------------------------------------------------------+
double LastOpPrice(int magik = 0, int typ = -1, int res = 0, string sy = ""){int i,t;double pr,sl,tpp;
   if(sy == ""){sy = Symbol();}
   for(i = OrdersTotal()-1; i>=0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()!=sy){continue;}
         if(OrderCloseTime()!=0){continue;}
         if(OrderType()==typ||typ==-1){
            if(OrderMagicNumber()==magik||magik==0){
            	if(OrderOpenTime()>t){
            		t  = OrderOpenTime();
            		pr = OrderOpenPrice();
            		sl = OrderStopLoss();
            		tpp = OrderTakeProfit();
            	}
            }
         }
      }
   }
   if(res==0){return(pr);}
   if(res==1){return(sl);}
   if(res==2){return(tpp);}
}
//+------------------------------------------------------------------+
//|   TP  SL                                  |
//|  Converts a distance in pips in cash equivalent,                 |
//|  at a certain trading lot (multi currency - variant)             |
//+------------------------------------------------------------------+
double MoneyToPoints(double mny=0,double lot=0,string symb=""){
   if(mny==0||lot==0){return(0);}
   if(symb == ""){symb  = Symbol();}   
   return(mny/(MarketInfo(symb,MODE_TICKVALUE)*lot));
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int PointsToMoney(double mny=0,double lot=0,string symb=""){
   if(mny==0||lot==0){return(0);}
   if(symb == ""){symb  = Symbol();}
}
//+------------------------------------------------------------------+
//|Returns the open price (Bid\Ask) for trading operation of its type|
//+------------------------------------------------------------------+
double Prices(int typ){
   RefreshRates();
   if(typ==0||typ==2||typ==4){return(Ask);}
   if(typ==1||typ==3||typ==5){return(Bid);}
}
//+------------------------------------------------------------------+
//|  Returns the color of trading operation on the type of           |
//+------------------------------------------------------------------+
color  GetOrdCl(int typ){
   if(typ==0||typ==2||typ==4){return(Blue);}
   if(typ==1||typ==3||typ==5){return(Red );}
   return(Green);
}
//+------------------------------------------------------------------+
//|                     |
//|  Returns the name passed her timeframe                           |
//+------------------------------------------------------------------+
string tf2txt(int tf=0){
   if (tf <= 0){tf = Period();}
   if (tf == PERIOD_M1)    return("Period M1 ");
   if (tf == PERIOD_M5)    return("Period M5 ");
   if (tf == PERIOD_M15)   return("Period M15");
   if (tf == PERIOD_M30)   return("Period M30");
   if (tf == PERIOD_H1)    return("Period H1 ");
   if (tf == PERIOD_H4)    return("Period H4 ");
   if (tf == PERIOD_D1)    return("Period D1 ");
   if (tf == PERIOD_W1)    return("Period W1 ");
   if (tf == PERIOD_MN1)   return("Period MN1");
}
//+------------------------------------------------------------------+
//|                                     |
//|  Returns the name of the trading operation                       |
//+------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("BuyLimit");
    case OP_SELLLIMIT: return("SellLimit");
    case OP_BUYSTOP  : return("BuyStop");
    case OP_SELLSTOP : return("SellStop");
    default          : return("Unknown Operation");
  }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string dts(double in, int pr){return(DoubleToStr(in,pr));}
//+------------------------------------------------------------------+
//|                |
//|  Normalizes the values of the accuracy of quotes                 |
//+------------------------------------------------------------------+
double nd(double in){return(NormalizeDouble(in,Digits));}
//+------------------------------------------------------------------+
//|                |
//|                                             |
//|  Normalizes the values of the accuracy of quotes                 |
//|  Multi-currency variant                                          |
//+------------------------------------------------------------------+
double nds(double in, string sy=""){
   if(sy==""){sy=Symbol();}
   return(NormalizeDouble(in,MarketInfo(sy,MODE_DIGITS)));
}
//+------------------------------------------------------------------+
//|     4\5                              |
//|  Gets the multiplier for the 4 / 5 digits                        |
//+------------------------------------------------------------------+
double mno(){if(Digits==3||Digits==5){return(10);}else{return(1);}}
//+------------------------------------------------------------------+
//|                         |
//|  y =        x              |
//|    < 0  ,         |
//+------------------------------------------------------------------+
double PersAbs(double x=0,double y=0){
	if(y>=0){return(-y);}
	return(nd((x/100)*y));
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool NewBar(){static int preTime;
	if(preTime == 0){preTime = Time[0];}
	if(preTime < Time[0]){
		preTime = Time[0];
		return(true);
	}
	return(false);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int PeriodCorrect(int per){
	if (per<15  					){return(1);}
   if (per>=5  	&& per<15  	){return(5);}
   if (per>=15 	&& per<30  	){return(15);}
   if (per>=30 	&& per<60  	){return(30);}
   if (per>=60 	&& per<240 	){return(60);}
   if (per>=240	&& per<1440	){return(240);}
   if (per>=1440	&& per<10080){return(1440);}
   if (per>=10080	&&per<43200	){return(10080);}
   if (per>=43200					){return(43200);}
   return(Period());
}
//+------------------------------------------------------------------+
//|  Fast processing of the most common errors to send orders        |
//+------------------------------------------------------------------+
bool Fun_Error(int err) {
   switch (err) {
   case 0:	return (true);
   case 1:	return (true);
   case 4:
      GetInfo("Trade server is busy. Trying once again..");
      Sleep(3000);
      return (true);
   case 135:
      GetInfo("Price changed. Trying once again..");
      RefreshRates();
      return (true);
   case 136:
      GetInfo("No prices. Waiting for a new tick..");
      while (RefreshRates() == FALSE) Sleep(1);
      return (true);
   case 137:
      GetInfo("Broker is busy. Trying once again..");
      Sleep(3000);
      return (true);
   case 146:
      GetInfo("Trading subsystem is busy. Trying once again..");
      Sleep(500);
      return (true);
   case 2:
      GetInfo("Common error.");
      return (true);
   case 5:
      GetInfo("Old terminal version.");
      return (false);
   case 64:
      GetInfo("Account blocked.");
      return (false);
   case 133:
      GetInfo("Trading forbidden.");
      return (false);
   case 134:
      GetInfo("Not enough money to execute operation.");
      return (false);
   case 147:
      GetInfo("Expirations are denied by broker.");
      //Expiration = false;
      return (false);
   }   
   GetInfo("Error occurred: "+ ErrorDescription(err)+"  "+err);
   return (true);
}
//+------------------------------------------------------------------+
//| return error description                                         |
//+------------------------------------------------------------------+
string ErrorDescription(int error_code)
  {
   string error_string;
//----
   switch(error_code)
     {
      //---- codes returned from trade server
      case 0:
      case 1:   error_string="no error";                                                  break;
      case 2:   error_string="common error";                                              break;
      case 3:   error_string="invalid trade parameters";                                  break;
      case 4:   error_string="trade server is busy";                                      break;
      case 5:   error_string="old version of the client terminal";                        break;
      case 6:   error_string="no connection with trade server";                           break;
      case 7:   error_string="not enough rights";                                         break;
      case 8:   error_string="too frequent requests";                                     break;
      case 9:   error_string="malfunctional trade operation (never returned error)";      break;
      case 64:  error_string="account disabled";                                          break;
      case 65:  error_string="invalid account";                                           break;
      case 128: error_string="trade timeout";                                             break;
      case 129: error_string="invalid price";                                             break;
      case 130: error_string="invalid stops";                                             break;
      case 131: error_string="invalid trade volume";                                      break;
      case 132: error_string="market is closed";                                          break;
      case 133: error_string="trade is disabled";                                         break;
      case 134: error_string="not enough money";                                          break;
      case 135: error_string="price changed";                                             break;
      case 136: error_string="off quotes";                                                break;
      case 137: error_string="broker is busy (never returned error)";                     break;
      case 138: error_string="requote";                                                   break;
      case 139: error_string="order is locked";                                           break;
      case 140: error_string="long positions only allowed";                               break;
      case 141: error_string="too many requests";                                         break;
      case 145: error_string="modification denied because order too close to market";     break;
      case 146: error_string="trade context is busy";                                     break;
      case 147: error_string="expirations are denied by broker";                          break;
      case 148: error_string="amount of open and pending orders has reached the limit";   break;
      case 149: error_string="hedging is prohibited";                                     break;
      case 150: error_string="prohibited by FIFO rules";                                  break;
      //---- mql4 errors
      case 4000: error_string="no error (never generated code)";                          break;
      case 4001: error_string="wrong function pointer";                                   break;
      case 4002: error_string="array index is out of range";                              break;
      case 4003: error_string="no memory for function call stack";                        break;
      case 4004: error_string="recursive stack overflow";                                 break;
      case 4005: error_string="not enough stack for parameter";                           break;
      case 4006: error_string="no memory for parameter string";                           break;
      case 4007: error_string="no memory for temp string";                                break;
      case 4008: error_string="not initialized string";                                   break;
      case 4009: error_string="not initialized string in array";                          break;
      case 4010: error_string="no memory for array\' string";                             break;
      case 4011: error_string="too long string";                                          break;
      case 4012: error_string="remainder from zero divide";                               break;
      case 4013: error_string="zero divide";                                              break;
      case 4014: error_string="unknown command";                                          break;
      case 4015: error_string="wrong jump (never generated error)";                       break;
      case 4016: error_string="not initialized array";                                    break;
      case 4017: error_string="dll calls are not allowed";                                break;
      case 4018: error_string="cannot load library";                                      break;
      case 4019: error_string="cannot call function";                                     break;
      case 4020: error_string="expert function calls are not allowed";                    break;
      case 4021: error_string="not enough memory for temp string returned from function"; break;
      case 4022: error_string="system is busy (never generated error)";                   break;
      case 4050: error_string="invalid function parameters count";                        break;
      case 4051: error_string="invalid function parameter value";                         break;
      case 4052: error_string="string function internal error";                           break;
      case 4053: error_string="some array error";                                         break;
      case 4054: error_string="incorrect series array using";                             break;
      case 4055: error_string="custom indicator error";                                   break;
      case 4056: error_string="arrays are incompatible";                                  break;
      case 4057: error_string="global variables processing error";                        break;
      case 4058: error_string="global variable not found";                                break;
      case 4059: error_string="function is not allowed in testing mode";                  break;
      case 4060: error_string="function is not confirmed";                                break;
      case 4061: error_string="send mail error";                                          break;
      case 4062: error_string="string parameter expected";                                break;
      case 4063: error_string="integer parameter expected";                               break;
      case 4064: error_string="double parameter expected";                                break;
      case 4065: error_string="array as parameter expected";                              break;
      case 4066: error_string="requested history data in update state";                   break;
      case 4099: error_string="end of file";                                              break;
      case 4100: error_string="some file error";                                          break;
      case 4101: error_string="wrong file name";                                          break;
      case 4102: error_string="too many opened files";                                    break;
      case 4103: error_string="cannot open file";                                         break;
      case 4104: error_string="incompatible access to a file";                            break;
      case 4105: error_string="no order selected";                                        break;
      case 4106: error_string="unknown symbol";                                           break;
      case 4107: error_string="invalid price parameter for trade function";               break;
      case 4108: error_string="invalid ticket";                                           break;
      case 4109: error_string="trade is not allowed in the expert properties";            break;
      case 4110: error_string="longs are not allowed in the expert properties";           break;
      case 4111: error_string="shorts are not allowed in the expert properties";          break;
      case 4200: error_string="object is already exist";                                  break;
      case 4201: error_string="unknown object property";                                  break;
      case 4202: error_string="object is not exist";                                      break;
      case 4203: error_string="unknown object type";                                      break;
      case 4204: error_string="no object name";                                           break;
      case 4205: error_string="object coordinates error";                                 break;
      case 4206: error_string="no specified subwindow";                                   break;
      default:   error_string="unknown error";
     }
//----
   return(error_string);
  }
//+------------------------------------------------------------------+



